// $Header: $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.

unit MessagePump;

interface

procedure PumpSleep(MiliSecValue : cardinal);

implementation
uses
  IdGlobal,
  Messages,
  Windows;

procedure PumpSleep(MiliSecValue : cardinal);
var
  Dummy: DWord;
  EndTick: Cardinal;
  Msg: TMsg;
  StartTick: Cardinal;
  Timeout: Int64;
begin
  // Pump messages in order to receive COM events. Not needed in VCL Forms.
  StartTick := Ticks;
  EndTick := StartTick + MiliSecValue;
  repeat
    Timeout := EndTick - Ticks;
    if Timeout <= 0 then
      Break;
    if MsgWaitForMultipleObjects(0, Dummy, False, Timeout, QS_ALLINPUT) = 0 then
    begin
      if GetMessage(Msg, 0, 0, 0) then
      begin
        if Msg.Message = WM_QUIT then
          Halt;
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;
    end;
  until False;
end;

end.
