unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  StdCtrls, ExtCtrls, Buttons, INIFiles, Controls, Vcl.ComCtrls, Vcl.Samples.Spin,
  Vcl.OleServer,
  ActiveX,  //Fr PSaveArray !!!
  //
  Accessibility_TLB,
  MessagePump,   //?
  mscorlib_TLB,   //Enthlt Zertifikate: Wichtig !!!
  OpcLabs_BaseLib_TLB,
  OpcLabs_BaseLibForms_TLB,
  OpcLabs_EasyOpcForms_TLB,
  OpcLabs_EasyOpcUA_TLB,
  OpcLabs_EasyOpcClassic_TLB,
  System_TLB,
  System_Windows_Forms_TLB,
//
  _ComputerBrowserDialog,
  _EasyUAClient,
  _EasyUAClientConfiguration,
  _UABrowseDialog,
  _UADataDialog,
  _UAEndpointDialog,
  _UAHostAndEndpointDialog,
//
   System_Drawing_TLB, fs_iinterpreter, fs_synmemo, fs_ibasic;



type
  TFrmMain = class(TForm)
    TimerRead: TTimer;
    InpHost: TEdit;
    LabHost: TLabel;
    LabPort: TLabel;
    InpPort: TEdit;
    Memo1: TMemo;
    Label1: TLabel;
    Button1: TButton;
    GroupBox1: TGroupBox;
    Btn_Beenden: TButton;
    StatusBar1: TStatusBar;
    TimerWrite: TTimer;
    Edt_Url: TEdit;
    Lab_Url: TLabel;
    Label3: TLabel;
    Cbx_TimerRead: TCheckBox;
    Cbx_TimerWrite: TCheckBox;
    TimerRead_SpinEdit1: TSpinEdit;
    Label2: TLabel;
    fsBasic1: TfsBasic;
    fsScript1: TfsScript;
    LBlog: TListBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TimerReadTimer(Sender: TObject);
    procedure Meldung(var Liste: TListBox; Text: String);
    function GetProgramDir: String;
    procedure Button1Click(Sender: TObject);
    procedure Btn_BeendenClick(Sender: TObject);
    procedure Cbx_TimerReadClick(Sender: TObject);
    procedure Cbx_TimerWriteClick(Sender: TObject);
    procedure TimerWriteTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    zaehler_timer, zaehler_timer2 : Cardinal;
    zaehler_sekunden : LongInt;
    LastCheck        : Cardinal;
    Sende_Intervall  : Integer;
    Url_String, c_marke, Server_Endpunkt, Errortext : String;
    Testbeispiel_Read : Integer;
    SReadArray : WideString;
    SStringArray : array of string;

    Arguments: OleVariant;
    OPC_Client1, OPC_Client2: TEasyUAClient;
    //
    EasyDAClient1: _EasyDAClient;
    J, Jmax: Integer;
    log_createmultiple, Test_DotNetOPCUADemoServer : Bool;
    zeitstempel_1,zeitstempel_2, delta_t: Cardinal;
    ReadArguments1, ReadArguments2, ReadArguments3, ReadArguments4: _UAReadArguments;
    Result: _UAAttributeDataResult;
    AttributeData1, AttributeData2, AttributeData3, AttributeData4: _UAAttributeData;
    Results, Value: OleVariant;
    Value1, Value2, Value3, Value4: OleVariant;
    NodeId_ExpandedText1, NodeId_ExpandedText2 : String;
    NodeId_ExpandedText3, NodeId_ExpandedText4 : String;
    NodeId_ExpandedText1w : String;
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}

function TFrmMain.GetProgramDir: String;
begin
  result := ExtractFileDir(ParamStr(0));
end;



procedure TFrmMain.Btn_BeendenClick(Sender: TObject);
begin
   try
   TimerRead.Enabled := false;
   TimerWrite.Enabled := false;
   //
   Memo1.Lines.SaveToFile(GetProgramDir()+'\SoftingOPCClient.log');
   Application.ProcessMessages;
   LBlog.Items.SaveToFile(GetProgramDir()+'\SoftingOPCClient_Error.log');
   Application.ProcessMessages;
   //
   FreeAndNil(OPC_Client1);
   FreeAndNil(OPC_Client2);
   Application.ProcessMessages;
   //
   Close;
   except
   end;
end;

procedure TFrmMain.Button1Click(Sender: TObject);
begin
    Memo1.Clear;
    Application.ProcessMessages;
end;

procedure TFrmMain.Cbx_TimerReadClick(Sender: TObject);
begin
  try
    //Timer initialisierung
    if Cbx_TimerRead.Checked and (not TimerRead.Enabled) then begin
       TimerRead.Interval := TimerRead_SpinEdit1.Value;
    end;

    TimerRead.Enabled := Cbx_TimerRead.Checked;

  except
    on E: Exception do begin
       ShowMessage('Fehler# ' +  E.Message);
    end;
  end;
end;

procedure TFrmMain.Cbx_TimerWriteClick(Sender: TObject);
begin
  TimerWrite.Enabled := Cbx_TimerWrite.Checked;
end;


procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  INI: TINIFile;
begin

  try
(*
  INI := TINIFile.Create(GetProgramDir()+'\SoftingOPCClient.INI');
  INI.WriteString('COMM','Host',InpHost.Text);
  INI.WriteString('COMM','Port',InpPort.Text);
//INI.WriteInteger('COMM','Typ',rgp_data.ItemIndex);
  INI.Free;
*)
  except
  end;
end;

procedure TFrmMain.Meldung(var Liste: TListBox; Text: String);
begin
  try
    Liste.Items.Add(DateTimeToStr(Now) + ' - ' + Text);
  except
  end;

  try
    Liste.ItemIndex := Liste.Items.Count - 1;
    if Liste.Items.Count > 1000 then begin
      Liste.Items.Delete(0);
    end;
  except
    on E: Exception do begin
      Meldung(LBLog, 'TFrmMain.Meldung - Fehler #: ' +  E.Message);
    end;
  end;
end;


procedure TFrmMain.FormCreate(Sender: TObject);
var
  INI: TINIFile;
begin

  zaehler_timer     := 0;
  zaehler_timer2    := 0;
  LastCheck := Windows.GetTickCount;

  try
  INI := TINIFile.Create(GetProgramDir()+'\SoftingOPCClient.INI');
  InpHost.Text := INI.ReadString('COMM','Host','192.168.100.5');
  InpPort.Text := INI.ReadString('COMM','Port','4980');
  Server_Endpunkt := INI.ReadString('COMM','Server_Endpunkt','Softing_dataFEED_OPC_Suite_Server_Configuration1');
  INI.Free;
  except
    on E: Exception do begin
       StatusBar1.SimpleText := 'TFrmMain.Meldung - Fehler# ' +  E.Message;
    end;
  end;
  //
  c_marke := 'Step01';

  try
  StatusBar1.SimpleText := 'Test-Version';
  Memo1.Clear;
  //
  Sende_Intervall := TimerRead_SpinEdit1.Value;

  //Timer initialisierung
  TimerRead.Interval := TimerRead_SpinEdit1.Value;
  TimerRead_SpinEdit1.ReadOnly := false;

  //Softing OPC-Suite URL
  Url_String := Trim('opc.tcp://' + Trim(InpHost.Text) + ':' + Trim(InpPort.Text)
                                  + '/' + Server_Endpunkt);
  //
  Edt_Url.Text := Url_String;
  c_marke := 'Step02';

  Testbeispiel_Read := 1;

  Test_DotNetOPCUADemoServer := FALSE;//TRUE;

  // 4x OPC-Items fr READ : TEST/DNK/25.02.2019:

  if (Testbeispiel_Read = 1) then begin
      if (NOT Test_DotNetOPCUADemoServer) then Begin
         NodeId_ExpandedText1 := 'nsu=Local Items;s=Local Items.EAK_Test1.EAK_Testwert1_I4'; //TEST: OK,aber beim Read-OPC immer der gleiche WERT!?
//       NodeId_ExpandedText1 := 'ns=3;s=Local Items.EAK_Test1.EAK_Testwert1_I4';//TEST: OK, aber auch hier beim Read-OPC immer der gleiche WERT!?
         NodeId_ExpandedText2 := 'nsu=Local Items;s=Local Items.EAK_Test1.EAK_Testwert2_I4';
         NodeId_ExpandedText3 := 'nsu=Local Items;s=Local Items.EAK_Test1.EAK_Testwert3_R4';
         NodeId_ExpandedText4 := 'nsu=Local Items;s=Local Items.EAK_Test1.EAK_Testwert4_R4';
         end
      else begin
         //Softing OPC UA .NET Demoserver
         NodeId_ExpandedText1 := 'ns=2;s=/Static/All Profiles/Scalar Mass/Int16/Int16000'; //OK, funktioniert, das OPC-Read auch !!!
      end;
      end
  else begin
      NodeId_ExpandedText1 := 'nsu=Local Items;s=Local Items.EAK_Test1.EAK_Testwert1_I4';
  end;
  //OPCLabs-Test:
  NodeId_ExpandedText1w := NodeId_ExpandedText1;  //TEST !!!!

  //Formular anzeigen
  FrmMain.Show;
EXCEPT
    on E: Exception do begin
       ShowMessage('FormCreate(' + c_marke + ') - Fehler #: ' +  E.Message);
    end;
END;



end;



procedure TFrmMain.FormShow(Sender: TObject);
begin

TRY

if (Testbeispiel_Read = 1) then begin
    c_marke := 'Step03';
    ReadArguments1 := CoUAReadArguments.Create;
    c_marke := 'Step03.1';
    ReadArguments1.EndpointDescriptor.UrlString := Url_String;
    c_marke := 'Step03.2';
    ReadArguments1.NodeDescriptor.NodeId.format(NodeId_ExpandedText1); //TEST: Ok !

    if (NOT Test_DotNetOPCUADemoServer) then Begin
      c_marke := 'Step04';
      ReadArguments2 := CoUAReadArguments.Create;
      ReadArguments2.EndpointDescriptor.UrlString := Url_String;
      ReadArguments2.NodeDescriptor.NodeId.format(NodeId_ExpandedText2); //TEST !!!

      c_marke := 'Step05';
      ReadArguments3 := CoUAReadArguments.Create;
      ReadArguments3.EndpointDescriptor.UrlString := Url_String;
      ReadArguments3.NodeDescriptor.NodeId.format(NodeId_ExpandedText3); //TEST !!!

      c_marke := 'Step06';
      ReadArguments4 := CoUAReadArguments.Create;
      ReadArguments4.EndpointDescriptor.UrlString := Url_String;
      ReadArguments4.NodeDescriptor.NodeId.format(NodeId_ExpandedText4); //TEST !!!
    End;

    c_marke := 'Step07';
    if (NOT Test_DotNetOPCUADemoServer) then Begin
       Arguments := VarArrayCreate([0, 3], varVariant);
       Arguments[0] := ReadArguments1;
       Arguments[1] := ReadArguments2;
       Arguments[2] := ReadArguments3;
       Arguments[3] := ReadArguments4;
       End
    else begin
       Arguments := VarArrayCreate([0, 0], varVariant);
       Arguments[0] := ReadArguments1;
    End;
  end
else begin
    ReadArguments1 := CoUAReadArguments.Create;
    ReadArguments1.EndpointDescriptor.UrlString := Url_String;
    ReadArguments1.NodeDescriptor.NodeId.ExpandedText := NodeId_ExpandedText1;

    c_marke := 'Step03';
    Arguments := VarArrayCreate([0, 0], varVariant);
    Arguments[0] := ReadArguments1;
end;

  sleep(50);

  Memo1.Lines.Add('Create fr UA-Client-Objekte (Read & Write ...)');

  c_marke := 'Step08';

  //Mehrfaches Create fr UA-Client-Objekt?
  log_createmultiple := false;


  // Instantiate the client read object
  OPC_Client1 := TEasyUAClient.Create(nil);

  c_marke := 'Step09';
  // Instantiate the client write object
  OPC_Client2 := TEasyUAClient.Create(nil);

  c_marke := 'Step10';
  // Perform the operation
  TVarData(Results).VType := varArray or varVariant;

  sleep(50);


EXCEPT
    on E: Exception do begin
       Errortext := 'FormShow(' + c_marke + ') - Fehler #: ' +  E.Message;
       Meldung(LBLog, Errortext);
       ShowMessage(Errortext);
    end;
END;

end;



procedure TFrmMain.TimerReadTimer(Sender: TObject);
var

  //
  I: Integer;
  S: String;
  //

begin

  try
  c_marke := 'Step11';

  inc(zaehler_timer);
  //

  if (1 = 1) then begin
      //
      c_marke := 'Step12';
      //
      //1.Zeit-Messung:
      zeitstempel_1 := GetTickCount;

      AttributeData1 := OPC_Client1.Read(Url_String, NodeId_ExpandedText1);
      //2.Option
      Value1 := OPC_Client1.ReadValue(Url_String, NodeId_ExpandedText1);//TEST

      c_marke := 'Step13';
      //2.Zeit-Messung:
      zeitstempel_2 := GetTickCount;

      c_marke := 'Step14';
      //Ergebnisse bbzw. Werte anzeigen
      Memo1.Lines.Add('Read OPC-Item1: ' + NodeId_ExpandedText1);
      Memo1.Lines.Add('Value1 : ' + VarToStr(AttributeData1.Value));
      Memo1.Lines.Add('ServerTimestamp1: ' + DateTimeToStr(AttributeData1.ServerTimestamp));
      Memo1.Lines.Add('SourceTimestamp1: ' + DateTimeToStr(AttributeData1.SourceTimestamp));
      Memo1.Lines.Add('StatusCode1: ' + AttributeData1.StatusCode.ToString);
      Memo1.Lines.Add('Value1B: ' + VarToStr(Value1));

      c_marke := 'Step15';
      //Zeitdifferenz
      delta_t := zeitstempel_2 - zeitstempel_1; //Millisekunden
      Memo1.Lines.Add('Timer-Zhler: ' + IntToSTr(zaehler_timer) + '   DT: ' + IntToStr(delta_t));
  End;

  except
    on E: Exception do begin
       Meldung(LBLog, 'TimerReadTimer(' + c_marke + ') - Fehler #: ' +  E.Message);
    end;
  end;

end;



procedure TFrmMain.TimerWriteTimer(Sender: TObject);
begin

  try
  inc(zaehler_timer2);

  //Schreiben auf OPC-Items zum Softing-OPC-UA_Server

  Memo1.Lines.Add('WriteValue: ' + IntToStr(zaehler_timer2) + '  #Item: ' + NodeId_ExpandedText1w);
  // Perform the operation
  OPC_Client2.WriteValue(Url_String, NodeId_ExpandedText1w, zaehler_timer2);

  //OPC_Client1.WriteValue(Url_String, NodeId_ExpandedText1w, zaehler_timer2);  //TEST: Gleiches Verhalten

  except
    on E: Exception do begin
       Meldung(LBLog, 'TimerWriteTimer - Fehler#: ' +  E.Message);
    end;
  end;
end;


end.
