// $Header: $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.
//#region Example
// This example shows how to write values into 3 nodes at once, test for
// success of each write and display the exception message in case of failure.

class procedure WriteMultipleValues.TestSuccess;
var
  Arguments: OleVariant;
  Client: OpcLabs_EasyOpcUA_TLB._EasyUAClient;
  I: Cardinal;
  WriteResult: _UAWriteResult;
  WriteValueArguments1, WriteValueArguments2, WriteValueArguments3: _UAWriteValueArguments;
  Results: OleVariant;
  //
  Url_String, NodeId_ExpandedText1, NodeId_ExpandedText2 : String;
  NodeId_ExpandedText3, NodeId_ExpandedText4: String;

begin

  Url_String := 'opc.tcp://MAINLINE:4980/Softing_dataFEED_OPC_Suite_Configuration1';
  // 4x OPC-Items:  TEST/DNK/25.02.2019:
  NodeId_ExpandedText1 := 'nsu=Local Items;s=Local Items.EAK_Test2.EAK_Testwert1_I4';
  NodeId_ExpandedText2 := 'nsu=Local Items;s=Local Items.EAK_Test2.EAK_Testwert3_R4';
  NodeId_ExpandedText3 := 'nsu=Local Items;s=Local Items.EAK_Test2.EAK_Testwert5_String';
  NodeId_ExpandedText4 := 'nsu=Local Items;s=Local Items.EAK_Test2.EAK_Testwert555_String';

  WriteValueArguments1 := CoUAWriteValueArguments.Create;
//WriteValueArguments1.EndpointDescriptor.UrlString := 'http://opcua.demo-this.com:51211/UA/SampleServer';
//WriteValueArguments1.NodeDescriptor.NodeId.ExpandedText := 'nsu=http://test.org/UA/Data/;i=10221';
  WriteValueArguments1.EndpointDescriptor.UrlString := Url_String;
  WriteValueArguments1.NodeDescriptor.NodeId.ExpandedText := NodeId_ExpandedText1;
  WriteValueArguments1.Value := 23456;

  WriteValueArguments2 := CoUAWriteValueArguments.Create;
//WriteValueArguments2.EndpointDescriptor.UrlString := 'http://opcua.demo-this.com:51211/UA/SampleServer';
//WriteValueArguments2.NodeDescriptor.NodeId.ExpandedText := 'nsu=http://test.org/UA/Data/;i=10226';
  WriteValueArguments2.EndpointDescriptor.UrlString := Url_String;
  WriteValueArguments2.NodeDescriptor.NodeId.ExpandedText := NodeId_ExpandedText2;
  WriteValueArguments2.Value := 'This string cannot be converted to Single';

  WriteValueArguments3 := CoUAWriteValueArguments.Create;
//WriteValueArguments3.EndpointDescriptor.UrlString := 'http://opcua.demo-this.com:51211/UA/SampleServer';
//WriteValueArguments3.NodeDescriptor.NodeId.ExpandedText := 'nsu=http://test.org/UA/Data/;s=UnknownNode';
  WriteValueArguments3.EndpointDescriptor.UrlString := Url_String;
  WriteValueArguments3.NodeDescriptor.NodeId.ExpandedText := NodeId_ExpandedText4;
  WriteValueArguments3.Value := 'ABC';

  Arguments := VarArrayCreate([0, 2], varVariant);
  Arguments[0] := WriteValueArguments1;
  Arguments[1] := WriteValueArguments2;
  Arguments[2] := WriteValueArguments3;

  // Instantiate the client object
  Client := CoEasyUAClient.Create;

  // Modify values of nodes
  TVarData(Results).VType := varArray or varVariant;
  TVarData(Results).VArray := PVarArray(Client.WriteMultipleValues(
    PSafeArray(TVarData(Arguments).VArray)));

  // Display results
  for I := VarArrayLowBound(Results, 1) to VarArrayHighBound(Results, 1) do
  begin
    WriteResult := IInterface(Results[I]) as _UAWriteResult;
    if WriteResult.Succeeded then
      WriteLn('Result ', I, ' success')
    else
      WriteLn('Result ', I, ': ', WriteResult.Exception.GetBaseException.Message);
  end;

 //TEST_Ergebnis /DNK/25.02.2019: Erfolgreich, 1.Wert ok. 2- und 3- Wert Error!
 //FAZIT: Mit Fehlerabfrage ist sicherer fr das Delphi-Handling fr LDSServer!


end;
//#endregion Example
